package com.jiuqi.sql;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class FieldInfoList
{
    private List list;
    private HashMap finder;
    
    public FieldInfoList() {
        this.list = new ArrayList();
        this.finder = new HashMap();
    }
    
    public FieldInfo add() {
        final FieldInfo result = new FieldInfo();
        this.list.add(result);
        return result;
    }
    
    public void add(final FieldInfo fieldInfo) {
        this.list.add(fieldInfo);
    }
    
    public void add(final int index, final FieldInfo fieldInfo) {
        this.list.add(index, fieldInfo);
    }
    
    public int size() {
        return this.list.size();
    }
    
    public FieldInfo get(final int index) {
        return this.list.get(index);
    }
    
    public void remove(final int index) {
        this.list.remove(index);
    }
    
    public void clear() {
        this.list.clear();
    }
    
    public int find(final String fieldName) {
        final Integer result = this.finder.get(fieldName.toUpperCase());
        return (result == null) ? -1 : result;
    }
    
    public void refreshFinder() {
        this.finder.clear();
        for (int i = 0; i < this.size(); ++i) {
            this.finder.put(this.get(i).name.toUpperCase(), new Integer(i));
        }
    }
    
    public void copyFrom(final FieldInfoList source) {
        this.clear();
        for (int i = 0; i < source.size(); ++i) {
            final FieldInfo fi = (FieldInfo)source.get(i).clone();
            this.add(fi);
        }
        this.refreshFinder();
    }
    
    public static void main(final String[] args) {
    }
}
